#ifndef _FILE_H_
#define _FILE_H_

/*
 * layout of a directory entry
 * http://home.freeuk.net/foxy2k/disk/disk9.htm
 */
typedef struct fat_file_s {
  u_int8_t name[8];
  u_int8_t ext[3];
  char fab; /* file attribute byte */
  char reserved[10]; /* extra date */
  u_int16_t time;
  u_int16_t date;
  u_int16_t scluster;
  u_int32_t size;
} fat_file_t;


int write_file(int infd, int outfd, u_int start, u_int16_t len, u_int16_t cluster_size);
u_int first_cluster(int fd);
u_int root_dir(int fd);
void *dir_list(u_int scluster, int fd, int cluster_size, int len);
void undelete_file(char *filesystem, char *filename, u_int16_t scluster,
                   int numclusters, int cluster_size);

/* offsets for key data in MBR */
#define NUM_OF_FAT 0x10
#define SEC_PER_FAT 0x16
#define RESERVED_SEC 0x0E
#define NUM_OF_ROOT_DIR 0x11


#define FILE_INFO_LEN 0x20
#define FAB_DIRECTORY 0x10
#endif
